import pyglet
import pymunk as pm
from pymunk.vec2d import Vec2d

import state

DT = 1/60.

class GameWindow(pyglet.window.Window):
    
    def __init__(self, *args, **kwargs):
        pyglet.window.Window.__init__(self,*args,**kwargs)
        pm.init_pymunk()
        self.mpos = Vec2d(1,1)
        self.keys = pyglet.window.key.KeyStateHandler()
        self.push_handlers(self.keys)
        self.state = None
        self.set_state(state.GameState(self))
    
    def set_state(self,state):
        if self.state is not None:
            pyglet.clock.unschedule(self.state.update)
        self.remove_handlers(state)
        del self.state
        self.state = state
        self.push_handlers(state)
        pyglet.clock.schedule_interval(self.state.update, DT)
        
    def on_activate(self):
        pyglet.clock.unschedule(self.state.update)
        pyglet.clock.schedule_interval(self.state.update, DT)
        
    def on_deactivate(self):
        pyglet.clock.unschedule(self.state.update)
        
    def on_mouse_motion(self,x,y,dx,dy):
        self.mpos = Vec2d(x,y)
        
        
        
        